/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)labels.h    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

// Linked list of labels
struct labelList {
   int value;
   struct labelList* next;
};

// Add item to linked list
struct labelList* addLabel(struct labelList* currentList, int newlabel);

// Remove item from linked list
struct labelList* removeLabel(int label, struct labelList* currentList);

// Copy linked list
struct labelList* copyLabels(struct labelList* oldList);

// Delete linked list
void freeLabelList(struct labelList* currentList);

// Decide if item exist in list
int inList(struct labelList* listToSearch, int label);

// Create list of all values in an image
struct labelList* listLabels(unsigned char** inputImage, int rows, int cols);

// Send all values in list to standard out
void printLabelList(struct labelList* listToPrint);
