/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)my_matrix_stuff.h    2.0     08/16/00

The author performed this work while he was with the Department of
Electrical and Computer Engineering, The University of Texas at Austin,
Austin, TX.  Wade Schwartzkopf can be reached at wade@schwartzkopf.org.
The professors supervising the work were Prof. Alan C. Bovik,
bovik@ece.utexas.edu, and Prof. Brian L. Evans, bevans@ece.utexas.edu.
*/

/*  Set of utility functions to deal with images in memory  */

/* Allocate a 3D float matrix */
float*** allocate3DFloatMatrix(int dim1, int dim2, int dim3);

/* Free 3D float matrix */
int free3DFloatMatrix(float*** floatMatrix, int dim1, int dim2);

/*  Allocate a 2D byte matrix */
unsigned char** allocateByteMatrix(int height, int width);

/*  Deallocate a 2D byte matrix */
int freeByteMatrix(unsigned char **byteMatrix);

/*  Copy image */
void copy_image(unsigned char** inputImage, unsigned char** outputImage, int rows, int cols);

/*  Copy portion of image */
void copy_square(unsigned char** inputImage, unsigned char** outputImage, int lowX, int highX, int lowY, int highY);

/*  Convert image format  */
void byteToTwoD(unsigned char* ByteImage, unsigned char** byte2DImage, int rows, int cols);

/*  Convert image format */
void twoDToByte(unsigned char** byte2DImage, unsigned char* ByteImage, int rows, int cols);

/*  Read image from file */
int readImageAs2DByte(char* imageFile, unsigned char** byte2DImage, int* rows, int* cols);

/*  Write image to file */
void writeImageAs2DByte(char* imageFile, unsigned char** byte2DImage, int rows, int cols, int imageType);
