/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)points.c    1.0     02/24/00

The authors are with the Laboratory for Image and Video Engineering
at The University of Texas at Austin, and can be reached at
wade@.ece.utexas.edu.
*/

#include <math.h>
#include <stdlib.h>

#include "points.h"

struct pointList* addPoint(struct pointList* currentList, int newx, int newy)
{
   struct pointList* tempptr;

   tempptr = (struct pointList*) malloc(sizeof(struct pointList));
   tempptr->value.x=newx;
   tempptr->value.y=newy;
   tempptr->next=currentList;
   return tempptr;
}

void freePointList(struct pointList* currentList)
{
   struct pointList* tempptr;
   struct pointList* tempptr2;

   for(tempptr = currentList; tempptr; tempptr = tempptr2) {
      tempptr2 = tempptr->next;
      free(tempptr);
   }
}

struct pointList* listPoints(unsigned char** inputImage, int lowX, int highX, int lowY, int highY)
{
   int i,j;
   struct pointList* currentList=NULL;

   for(i = lowY; i <= highY; i++) {
      for(j = lowX; j <= highX; j++) {
         if(inputImage[i][j]>0) {
            currentList=addPoint(currentList, j, i);
         }
      }
   }

   return currentList;
}

void printPointList(struct pointList* listToPrint)
{
   struct pointList* tempptr;

   for(tempptr = listToPrint; tempptr; tempptr = tempptr->next) {
      printf("x = %d; y = %d\r\n", tempptr->value.x, tempptr->value.y);
   }
}

void addToImage(unsigned char** inputImage, struct pointList* newPoints, int value)
{
   struct pointList* tempptr;

   for(tempptr = newPoints; tempptr; tempptr = tempptr->next) {
      inputImage[tempptr->value.y][tempptr->value.x]=value;
   }
}
