/*
Copyright (c) 2001 The University of Texas
All Rights Reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

The GNU Public License is available in the file LICENSE, or you
can write to the Free Software Foundation, Inc., 59 Temple Place -
Suite 330, Boston, MA 02111-1307, USA, or you can find it on the
World Wide Web at http://www.fsf.org.

Programmers:    Wade Schwartzkopf
Version:        @(#)segmentation.h    2.0     08/16/00

The author performed this work while he was with the Department of
Electrical and Computer Engineering, The University of Texas at Austin,
Austin, TX.  Wade Schwartzkopf can be reached at wade@schwartzkopf.org.
The professors supervising the work were Prof. Alan C. Bovik,
bovik@ece.utexas.edu, and Prof. Brian L. Evans, bevans@ece.utexas.edu.
*/

#include "imgtools.h"
#include "points.h"
#include "classify.h"

#define THRESH_SIZE 10 // Smallest chromosome size (in pixels)
#define THRESH_PROB 1/10.0 // Any object with probability less that this is
                           // questionable

// Segment chromosome image from raw MFISH image (inputMFISH)
// Return image of labelled objects (outputImage)
void segment(MFISH inputMFISH, unsigned char** mask, struct trainDataStruct* trainData, unsigned char** outputImage, int rows, int cols);

